/*---------------------------------------------------------------------------
  This code is part of the book
  LOGIC PROGRAMMING TECHNIQUES: THE PROLOG LANGUAGE
  Ilias Sakellariou, Nikos Bassiliades, Petros Kefalas, Demosthenes Stamatis
  Hellenic Academic On-line Publications, 2015
----------------------------------------------------------------------------*/

:-op(60,fx,attribute).
:-op(50,xfy,of).
:-op(50,xfx,has_value).

/*------------------------------------------------------------------
               KNOWLEDGE REPRESENTED AS A FRAME STRUCTURE
-------------------------------------------------------------------*/

frame(thing).
frame(mammal).
frame(plant).
frame(fruit).
frame(banana).
frame(monkey).
frame(tree).
frame(cat).
frame(dog).
frame(human).
frame(man).
frame(woman).

frame_prop(mammal, isa, thing).
frame_prop(plant, isa, thing).
frame_prop(fruit, isa, thing).
frame_prop(banana, isa, fruit).
frame_prop(monkey, isa, mammal).
frame_prop(human, isa, mammal).
frame_prop(man, isa, human).
frame_prop(woman, isa, human).
frame_prop(cat, isa, mammal).
frame_prop(dog, isa, mammal).
frame_prop(tree, isa, plant).

frame_prop(monkey, likes, banana).
frame_prop(man, likes, woman).
frame_prop(mammal, eats, fruit).
frame_prop(banana, edible, true).
frame_prop(dog, hates, cat).
frame_prop(human, enjoys, hunting).

/*------------------------------------------------------------------
               RETRIEVING PROPARTIES FROM FRAME HIERARCY
-------------------------------------------------------------------*/
property(O,A,V):-
	frame_prop(O,A,V).
property(O,A,V):-
	frame_prop(O,isa,SuperClass),
	property(SuperClass, A, V)!.

attribute A of O has_value V :-
	property(O,A,V).
